#ifndef LISTADE_H
#define LISTADE_H

#include <iostream>
#include <conio.h>

using namespace std;

class Nodo2{
	friend class ListaDE;

public:
	
	Nodo2(){};

private:
	int Dato;
	Nodo2 *Izquierda;
	Nodo2 *Derecha;
};

class ListaDE{
private:
        int Poli;
        int Info2;
        int conts;
public:
	ListaDE();
	~ListaDE();
	void ActualizarFrente(int,int Info2,int conts);
	void InsertarFrente(int);
	void InsertarFinal(int);
	void EliminarNodo(int);
	void RemoverFrente();
	void RemoverFinal();
	int EstaVacia(){return PtrFrente==NULL;};
	void ImprimirLista();
	int Pol(int Info);
private:
	Nodo2 *PtrFrente;
	Nodo2 *PtrFinal;

};

ListaDE::ListaDE():PtrFrente(NULL), PtrFinal(NULL){}

ListaDE::~ListaDE(){

	Nodo2 *Tmp;
		
	if(!EstaVacia()){
		while(PtrFrente!=NULL){

			Tmp=PtrFrente;
			PtrFrente=PtrFrente->Derecha;
			cout<<"Borrando Dato..."<<Tmp->Dato;
			delete Tmp;
		}
	}
}

int ListaDE::Pol(int Info){
     Nodo2 *NodoAMostrar;
	
	 NodoAMostrar=PtrFinal;
	 Poli=0;
     while(Poli!=Info)
     {
                      NodoAMostrar=NodoAMostrar->Izquierda;
     Poli++;}
                             return NodoAMostrar->Dato;
     
     
     };
     
void ListaDE::ActualizarFrente(int Info, int Info2, int conts){
     int actua;
	Nodo2 *NodoAMostrar;
	
    NodoAMostrar=PtrFinal;
	Poli=0;
	
    for(actua=0;actua<conts;actua++)
	NodoAMostrar=NodoAMostrar->Izquierda;
	
    while(Poli!=Info)
                             {
                             NodoAMostrar=NodoAMostrar->Izquierda;
                             Poli++;
                             }
                            NodoAMostrar->Dato=NodoAMostrar->Dato+Info2;
	
}
void ListaDE::InsertarFrente(int Info){

	Nodo2 *NuevoNodo= new Nodo2;
	

	if(NuevoNodo==NULL)
		cout<<"Memoria Insuficiente...";
	else{
	NuevoNodo->Dato =Info;
		if(EstaVacia()){
			NuevoNodo->Derecha =PtrFrente;
			PtrFrente=NuevoNodo;
			PtrFinal=NuevoNodo;
		}
		else{
			PtrFrente->Izquierda =NuevoNodo;
			NuevoNodo->Derecha =PtrFrente;
			NuevoNodo->Izquierda =NULL;
			PtrFrente=NuevoNodo;
			
		}

	}
	
}

void ListaDE::InsertarFinal(int Info){

		Nodo2 *NuevoNodo= new Nodo2;
		

	if(NuevoNodo==NULL)
		cout<<"Memoria Insuficiente...";
	else{
	NuevoNodo->Dato =Info;
		if(EstaVacia()){
		
			NuevoNodo->Derecha  =PtrFrente;
			PtrFrente=NuevoNodo;
			PtrFinal=NuevoNodo;
			
		}
		else{
			PtrFinal->Derecha =NuevoNodo;
			NuevoNodo->Izquierda =PtrFinal;
			NuevoNodo->Derecha  =NULL;
			PtrFinal=NuevoNodo;			
		}

	}
}

void ListaDE::RemoverFrente(){

	Nodo2 *Tmp;

	if(EstaVacia())
		cout<<"La lista ya est vaca..."<<endl;
	else
	{
		Tmp=PtrFrente;
		PtrFrente=PtrFrente->Derecha ;
		PtrFrente->Izquierda =NULL;
		delete Tmp;
	}
}

void ListaDE::RemoverFinal(){

	Nodo2 *Tmp;

	if(EstaVacia())
		cout<<"La lista ya est vaca..."<<endl;
	else
	{
	Tmp=PtrFinal;
		if(PtrFinal==PtrFrente)
			PtrFrente=NULL;

		else{
		
		PtrFinal=PtrFinal->Izquierda;
		PtrFinal->Derecha  =NULL;
		}
		delete Tmp;
	}
}


void ListaDE::EliminarNodo(int Info){

	int Encontrado;
	Encontrado=0;

	Nodo2 *NodoABorrar;
		
	NodoABorrar=PtrFrente;
	

	if(PtrFrente->Dato ==Info){
		PtrFrente=PtrFrente->Derecha;
		PtrFrente->Izquierda =NULL;
		delete NodoABorrar;
	}

	else if(PtrFinal->Dato ==Info){

		while(NodoABorrar->Derecha  !=PtrFinal)
			NodoABorrar=NodoABorrar->Derecha;
			
		PtrFinal=NodoABorrar;
		NodoABorrar=PtrFinal->Derecha;
		PtrFinal->Derecha  =NULL;
		delete NodoABorrar;
		
	}

	else {

		
		while(NodoABorrar!=NULL){
			if(NodoABorrar->Dato ==Info){
				Encontrado=1;
				break;}
			else{
				NodoABorrar=NodoABorrar->Derecha;			
			}
		}

	
		if(Encontrado){
		NodoABorrar->Izquierda->Derecha=NodoABorrar->Derecha;
		NodoABorrar->Derecha->Izquierda =NodoABorrar->Izquierda;
		delete NodoABorrar;
		}
	}
	
}

void ListaDE::ImprimirLista(){
     	Nodo2 *NodoAMostrar;
	
	NodoAMostrar=PtrFrente;
	
    while(NodoAMostrar!=PtrFinal)
                             {
                             cout<<NodoAMostrar->Dato<<" ";
                             NodoAMostrar=NodoAMostrar->Derecha;
                             }
    cout<<NodoAMostrar->Dato<<endl;
     
     
     }
     
     
#endif
